<script setup lang="ts">
import { ArrowRight, PricingPlans } from 'slippers-ui/icons';

import type { BaseLink, BaseIcon } from '@/types/base';

defineProps({
  icon: {
    type: Object as PropType<BaseIcon>,
    required: true,
  },
  title: {
    type: String,
    required: false,
  },
  button: {
    type: Object as PropType<BaseLink>,
    required: true,
  },
  shimmerButton: {
    type: Object as PropType<BaseLink>,
    required: true,
  },
});
</script>

<template>
  <section class="pricing-blurb">
    <SlpContainer>
      <SlpIcon class="icon" size="48" :icon="PricingPlans" />
      <SlpRow>
        <SlpColumn cols="8">
          <SlpTypography variant="heading2-bold" tag="h2">
            {{ title }}
          </SlpTypography>
        </SlpColumn>
        <SlpColumn cols="4" class="button-container">
          <SlpButton
            class="button"
            :href="button.config.href"
            variant="primary"
            :data-ga-name="button.config.dataGaName"
            :data-ga-location="button.config.dataGaLocation"
            >{{ button.text }}
            <SlpIcon :icon="ArrowRight" size="sm" class="slp-ml-8" />
          </SlpButton>
          <SlpButton
            class="button shimmer"
            :href="shimmerButton.config.href"
            variant="primary"
            :data-ga-name="shimmerButton.config.dataGaName"
            :data-ga-location="shimmerButton.config.dataGaLocation"
            >{{ shimmerButton.text }}
            <SlpIcon :icon="ArrowRight" size="sm" class="slp-ml-8" />
          </SlpButton>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.icon {
  margin-bottom: $spacing-24;
}

.pricing-blurb {
  background-color: $color-surface-800;
  padding: $spacing-96 0 $spacing-160 0;
}

.button-container {
  display: flex;
  flex-direction: column;

  @media (max-width: $breakpoint-sm) {
    margin-top: $spacing-48;
    width: 100%;

    .button {
      width: 100%;
    }
  }

  .button {
    background-color: $color-surface-950;
    border: none;
    color: $color-text-300;
    border-radius: 4px;
    overflow: hidden;
    padding: 18px 16px;
    justify-content: center;
    margin: 0 auto 8px auto;
    transition: all 0.3s ease;

    &:hover {
      background-color: $color-surface-900;
      border: 0;
    }

    &.shimmer {
      background: linear-gradient(
        93.83deg,
        rgba(199, 177, 254, 0.75) 7.27%,
        rgba(255, 212, 216, 0.75) 105.33%
      ) !important;

      color: $color-primary-200 !important;
      border: none !important;
      position: relative;
      overflow: hidden;

      &:after {
        content: '';
        position: absolute;
        top: 0;
        left: -200%;
        width: 200%;
        height: 100%;
        transform: skewX(-20deg);
        background-image: linear-gradient(to right, transparent, rgba(255, 255, 255, 0.5), transparent);
      }

      &:hover:after {
        animation: shine 0.8s ease-in-out;
      }
    }
  }
}
</style>
